// 
// The Waveset SPML General License 
// 
// Version 0.1, April 2003
// Copyright (C) 2003 Waveset Technologies, Inc..
// 6034 West Courtyard Drive, Suite 210, Austin, Texas 78730
// All rights reserved.
// 
// TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are
// met:
// 
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions, and the disclaimers in Sections 6
//    and 7 below.
// 
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the disclaimers in Sections 6
//    and 7 below in the documentation and/or other materials provided
//    with the distribution.
// 
// 3. The end-user documentation included with the redistribution, if
//    any, must include the following acknowledgment:
// 
//    "This product includes software developed by 
//     Waveset Technologies, Inc. (www.waveset.com)."
// 
//    Alternately, this acknowledgment may appear in the software itself, if
//    and wherever such third-party acknowledgments normally appear.
//  
// 4. The names "Waveset" and "Waveset Technologies, Inc." must not be
//    used to endorse or promote products derived from this software
//    without the prior written permission of Waveset. For written
//    permission, please contact www.waveset.com.
//  
// 5. Products derived from this software may not be called "Waveset",
//    nor may "Waveset" appear in their name, without the prior written
//    permission of Waveset.
//  
// 6. NO WARRANTY 
// 
//    THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED
//    OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
//    WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
//    DISCLAIMED.
// 
// 7.  LIMITATION OF LIABILITY
// 
//    IN NO EVENT SHALL THE WAVESET OR ITS LICENSORS BE LIABLE FOR ANY
//    DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
//    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
//    GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
//    INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
//    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
//    OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
//    ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// 
// End of Terms and Conditions
// ====================================================================
//
// Component Name: org.openspml.message.AddRequest
//
// Author(s): Jeff Larson
//
// Description:
//
// Memory representation for an <addRequest> element.
//
//

package org.openspml.message;

import java.util.*;
import org.openspml.util.*;

/**
 * A class used to represent an <code>addRequest</code> element.
 * <p>
 * An add request essentially just provides a list of arbitrary attribute
 * values for the new object.  The <code>objectclass</code>
 * attribute is however special in that it may specify the class
 * of the object being created.   If not specified, the provider may
 * use a default object class, but this is not required.
 */
public class AddRequest extends SpmlRequest {

    //////////////////////////////////////////////////////////////////////
    //
    // Fields
    //
    //////////////////////////////////////////////////////////////////////

    static final String ELEMENT = "addRequest";
    
    /**
     * A list of Attribute objects.
     */
    List _attributes;

    //////////////////////////////////////////////////////////////////////
    //
    // Constructors
    //
    //////////////////////////////////////////////////////////////////////

    /**
     * Construct an object representing an SPML <code>addRequest</code>
     * message.
     */
    public AddRequest() {
    }

    /**
     * Construct an AddRequest object from a DOM tree.
     */
    AddRequest(XmlElement e) {
	parseXml(e);
    }

    public SpmlResponse createResponse() {
        return new AddResponse();
    }

    /**
     * Sets the list of attributes.  The list is expected to 
     * contain <code>Attribute</code> objects.
     */
    public void setAttributes(List l) {
        _attributes = l;
    }

    /**
     * Sets the attributes from a map of name/value pairs.
     */
    public void setAttributes(Map map) {
        if (map == null)
            _attributes = null;
        else {
            Iterator it = map.entrySet().iterator();
            while (it.hasNext()) {
                Map.Entry entry = (Map.Entry)it.next();
                String name = (String)entry.getKey();
                if (name != null)
                    setAttribute(name, entry.getValue());
            }
        }
    }

    /**
     * Sets one attribute.
     */
    public void setAttribute(Attribute a) {
        if (_attributes == null)
            _attributes = new ArrayList();
        _attributes.add(a);
    }
    
    /**
     * Sets one attribute as a name/value pair.
     */
    public void setAttribute(String name, Object value) {
        setAttribute(new Attribute(name, value));
    }

    /**
     * Sets the class of the object being added.
     * <p>
     * This is just represented as an Attribute, but since it   
     * is has specified semantics, we give it its own method.
     */
    public void setObjectClass(String s) {
        setAttribute("objectclass", s);
    }


    //////////////////////////////////////////////////////////////////////
    //
    // Accessors
    //
    //////////////////////////////////////////////////////////////////////

    /**
     * Retrieve the list of attributes.
     */
    public List getAttributes() {
        return _attributes;
    }

    /**
     * Retrieve an attribute by name.
     */
    public Attribute getAttribute(String name) {
        return Attribute.getAttribute(_attributes, name);
    }

    /**
     * Retrieve the value of an attribute.
     */
    public Object getAttributeValue(String name) {
        return Attribute.getAttributeValue(_attributes, name);
    }

    /**
     * Retrieve the value of the "objectclass" attribute.
     */
    public String getObjectClass() {
        return (String)getAttributeValue("objectclass");
    }

    //////////////////////////////////////////////////////////////////////
    //
    // XML
    //
    //////////////////////////////////////////////////////////////////////

    public String getElementName() {
        return ELEMENT;
    }

    void addSubclassElements(SpmlBuffer b) {

        Attribute.toXml(b, "attributes", _attributes);
    }

    void parseXml(XmlElement e) {

	super.parseXml(e);
	
	for (XmlElement child = e.getChildElement() ; 
	     child != null ; child = child.next()) {
	    String tag = child.getLocalName();
	    if (tag.equals("attributes"))
		_attributes = Attribute.parseList(child);
	}
    }
 
}
